/*
 * 
 * Copyright (c) 2016, H.R.Z. Software services LTD
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions 
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer 
 *    in the documentation and/or other materials provided with the distribution.
 * 
 * 3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from 
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace DIHOFA
{
    /// <summary>
    /// Class for writing messages in the system Event Log 
    /// </summary>
    public class EventLogger
    {
        static string mAppName;

        /// <summary>
        /// Constructor
        /// If Event source for the application doesn't exist create it
        /// </summary>
        static EventLogger()
        {
            try
            {
                mAppName = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name;

                ///////////////////////////////////////////////////////////////////////////////
                // Comment out !!!
                //EventLog.Delete(mAppName);
                ///////////////////////////////////////////////////////////////////////////////

                if (!EventLog.Exists(mAppName) || !EventLog.SourceExists(mAppName))
                {
                    if (!EventLog.Exists(mAppName) && EventLog.SourceExists(mAppName))
                    {
                        EventLog.DeleteEventSource(mAppName);
                    }
                    EventLog.CreateEventSource(mAppName, mAppName);
                }

            }
            catch (Exception ex)
            {
                //Not admin user
                string t = ex.Message;
            }


        }

        /// <summary>
        /// Writes message
        /// </summary>
        /// <param name="type">Type of the message (error, information etc.)</param>
        /// <param name="message"></param>
        static public void LogEvent(EventLogEntryType type, string message)
        {
            try
            {
                EventLog.WriteEntry(mAppName, message, type);
            }
            catch (Exception)
            {
                //Log might be not created
            }
        }
    }
}
